PATH=c:\gba\devkitadv\bin;%PATH%

NAME = Demo
CARMFLAGS	= -c -O2 -marm -mthumb-interwork -Wall -ffreestanding
CTHUMBFLAGS	= -c -O2 -mthumb -mthumb-interwork -Wall -ffreestanding
LDFLAGS	= -T lnkscript
all : $(NAME).bin

$(NAME).bin : $(NAME).elf
	objcopy -v -O binary $(NAME).elf $(NAME).bin

$(NAME).elf : crt0.o main.o misc.o irq.text.iwram.o data.o math.o sound.o sound.text.iwram.o sndmix.o song.o font.o string.o 
	ld $(LDFLAGS) -o $(NAME).elf crt0.o main.o misc.o irq.text.iwram.o data.o math.o sound.o sound.text.iwram.o sndmix.o song.o font.o string.o 

crt0.o : crt0.S
	gcc $(CTHUMBFLAGS) crt0.S

main.o : main.c
	gcc $(CTHUMBFLAGS) main.c

misc.o : misc.c
	gcc $(CTHUMBFLAGS) misc.c

irq.text.iwram.o : irq.text.iwram.c
	gcc $(CARMFLAGS) -mthumb-interwork irq.text.iwram.c

data.o : data.c
	gcc $(CTHUMBFLAGS) data.c

math.o : math.s
	gcc $(CTHUMBFLAGS) math.s

sound.o : sound.c
	gcc $(CTHUMBFLAGS) sound.c

sound.text.iwram.o : sound.text.iwram.s
	gcc $(CARMFLAGS) sound.text.iwram.s

sndmix.o : sndmix.s
	gcc $(CTHUMBFLAGS) sndmix.s

song.o : song.c
	gcc $(CTHUMBFLAGS) song.c

font.o : font.c
	gcc $(CTHUMBFLAGS) font.c

string.o : string.c
	gcc $(CTHUMBFLAGS) string.c
