#include "main.h"

u32 irqTable[14];

void Irq()
{
	u16 flag;

	flag = REG_IF;
	if(flag & IRQ_VBL)
	{
		SndVSync();
		((fp)irqTable[IRQTABLE_VBL])();
	}

	else if(flag & IRQ_HBL)
		((fp)irqTable[IRQTABLE_HBL])();

	else if(flag & IRQ_YTRIG)
		((fp)irqTable[IRQTABLE_YTRIG])();

	else if(flag & IRQ_TM0)
		((fp)irqTable[IRQTABLE_TM0])();

	else if(flag & IRQ_TM1)
		((fp)irqTable[IRQTABLE_TM1])();

	else if(flag & IRQ_TM2)
		((fp)irqTable[IRQTABLE_TM2])();

	else if(flag & IRQ_TM3)
		((fp)irqTable[IRQTABLE_TM3])();

	else if(flag & IRQ_COMMS)
		((fp)irqTable[IRQTABLE_COMMS])();

	else if(flag & IRQ_DMA0)
		((fp)irqTable[IRQTABLE_DMA0])();

	else if(flag & IRQ_DMA1)
		((fp)irqTable[IRQTABLE_DMA1])();

	else if(flag & IRQ_DMA2)
		((fp)irqTable[IRQTABLE_DMA2])();

	else if(flag & IRQ_DMA3)
		((fp)irqTable[IRQTABLE_DMA3])();

	else if(flag & IRQ_KEY)
		((fp)irqTable[IRQTABLE_KEY])();

	else if(flag & IRQ_CART)
		((fp)irqTable[IRQTABLE_CART])();

	REG_IF = flag;
	*((volatile u16*)0x3007ff8) |= flag;
}

void IrqNull()
{
}

void SndVSync()
{
	if(pSndSong->state & SND_STATE_BUF)
	{
		REG_DM1CNT = 0;
		REG_DM2CNT = 0;
		REG_DM1SAD = sndMixBuf;
		REG_DM2SAD = sndMixBuf + (SND_MIXBUFSIZE << 1);
		REG_DM1CNT_H = 0xb640;
		REG_DM2CNT_H = 0xb640;
		sndCurMixBuf = sndMixBuf + SND_MIXBUFSIZE;
	}
	else
		sndCurMixBuf = sndMixBuf;
	pSndSong->state ^= SND_STATE_BUF;
}
