#include "main.h"

void *eWram;
u16 keyHold = 0xffff;
s32 *trigTable, *rcpTable;

int AgbMain()
{
	u32 i;

	eWram = (void*)0x2000000;

	REG_INTERRUPT = (u32)Irq;
	for(i = 0; i < 14; i++)
		irqTable[i] = (u32)IrqNull;
	SndInit(eWram, eWram + (SND_MIXBUFSIZE << 2));
	eWram += (SND_MIXBUFSIZE << 2) + sizeof(Song);
	REG_DISPSTAT = DSTAT_HBL_IRQ | DSTAT_VBL_IRQ | DSTAT_YTRIG_IRQ;
	REG_IE |= IRQ_HBL | IRQ_VBL | IRQ_YTRIG;
	REG_IME = 1;
	
	REG_BG0CNT = BG_CHAR(0) | BG_SCREEN(31);
	LoadBgPal16(15, dPalSys);
	FontLoad(0, 0);

	REG_DISPCNT = DCNT_MODE0 | DCNT_OBJ_MAP_1D | DCNT_OBJ_ENABLE | 
		DCNT_BG0_ENABLE | DCNT_BG1_ENABLE | 
		DCNT_BG2_ENABLE | DCNT_BG3_ENABLE;

	u8 chn = 4, samp = 0;
	u32 frame = 0, time;
	while(1)
	{
		if(KEY(KEY_A))
		{
			if(!(frame & 31))
			{
				if(KEY(KEY_B))
				{
					pSndSong->chnActive ^= 0x100 << chn;
				}
				else
				{
					if(pSndSong->chnActive & (1 << chn))
					{
						pSndSong->chnActive &= ~(1 << chn);
						if(chn < 4)
						{
							modChn[chn].data = dSndBlank;
							modChn[chn].inc = 0;
							modChn[chn].len = (SND_MIXBUFSIZE + 1) << SND_FP;
						}
						else
						{
							sndChn[chn - 4].data = dSndBlank;
							sndChn[chn - 4].len = SND_MIXBUFSIZE + 1;
						}
					}
					else
					{
						if(chn < 4)
						{
							modChn[chn].data = dSndTable[samp];
							modChn[chn].pos = 0;
							modChn[chn].inc = div(dSndFreq[samp] << 
								SND_FP, SND_FREQ);
							modChn[chn].loopLen = dSndLoop[samp] << SND_FP;
							modChn[chn].vol = 64;
							modChn[chn].len = dSndLength[samp] << SND_FP;
							pSndSong->chnActive |= 1 << chn;
						}
						else
						{
							sndChn[chn - 4].data = dSndTable[samp];
							sndChn[chn - 4].pos = 0;
							sndChn[chn - 4].len = dSndLength[samp];
							sndChn[chn - 4].loopLen = dSndLoop[samp];
							sndChn[chn - 4].lVol = 64;
							sndChn[chn - 4].rVol = 64;
							pSndSong->chnActive |= 1 << chn;
						}
					}
				}
			}
		}
		if(KEY(KEY_UP))
		{
			if(KEY(KEY_B))
			{
				if(chn >= 4)
				{
					if(!(frame & 7))
						if(sndChn[chn - 4].rVol < 64)
							sndChn[chn - 4].rVol++;
				}
			}
			else
			{
				if(chn < 4)
				{
					if(!(frame & 3))
						modChn[chn].inc++;
				}
			}
		}
		if(KEY(KEY_DOWN))
		{
			if(KEY(KEY_B))
			{
				if(chn >= 4)
				{
					if(!(frame & 7))
						if(sndChn[chn - 4].rVol > 0)
							sndChn[chn - 4].rVol--;
				}
			}
			else
			{
				if(chn < 4)
				{
					if(!(frame & 3))
						modChn[chn].inc--;
				}
			}
		}
		if(KEY(KEY_LEFT))
		{
			if(KEY(KEY_B))
			{
				if(chn >= 4)
				{
					if(!(frame & 7))
						if(sndChn[chn - 4].lVol > 0)
							sndChn[chn - 4].lVol--;
				}
				else
				{
					if(!(frame & 7))
						if(modChn[chn].vol > 0)
							modChn[chn].vol--;
				}
			}
			else
			{
				if(chn > 0)
				{
					if(!(frame & 31))
						chn--;
				}
			}
		}
		if(KEY(KEY_RIGHT))
		{
			if(KEY(KEY_B))
			{
				if(chn >= 4)
				{
					if(!(frame & 7))
						if(sndChn[chn - 4].lVol < 64)
							sndChn[chn - 4].lVol++;
				}
				else
				{
					if(!(frame & 7))
						if(modChn[chn].vol < 64)
							modChn[chn].vol++;
				}
			}
			else
			{
				if(chn < 5)
				{
					if(!(frame & 31))
						chn++;
				}
			}
		}
		if(KEY(KEY_L))
		{
			if(samp > 0)
				if(!(frame & 31))
					samp--;
		}
		if(KEY(KEY_R))
		{
			if(!(frame & 31))
				samp++;
		}
		if(KEY(KEY_START))
		{
			if(!(frame & 31))
			{
				if(pSndSong->state & SND_STATE_PLAY)
					SndSongStop();
				else
					SndSongPlay(dSongTable[0], 0, 0);
			}
		}
		if(KEY(KEY_SELECT))
		{
			if(!(frame & 31))
			{
				if(pSndSong->state & SND_STATE_PLAY)
					SndSongStop();
				else
					SndSongPlay(dSongTable[1], 0, 0);
			}
		}
		VSync();
		while(REG_VCOUNT != 1);
		PAL_BG[15] = RGB(31, 15, 0);
		REG_TM3D = 0;
		REG_TM3CNT = TIMER_ENABLE;
		SndMix();
		time = REG_TM3D;
		REG_TM3CNT = 0;
		PAL_BG[15] = RGB(0, 31, 0);
		SndSongUpdate();
		PAL_BG[15] = RGB(0, 0, 0);

		FontPrint(0, 0, BGS(31), 
			ltoa(pSndSong->chnActive), 5);
		FontPrint(19, 0, BGS(31), 
			ltoa(time), 5);
		FontPrint(0, 1, BGS(31), 
			"LEFT/RIGHT CHN:", 5);
		FontPrint(0, 2, BGS(31), 
			" B+LEFT/RIGHT LVOL:", 5);
		FontPrint(19, 1, BGS(31), ltoa(chn), 5);
		if(chn >= 4)
			FontPrint(19, 2, BGS(31), ltoa(sndChn[chn - 4].lVol), 5);
		else
			FontPrint(19, 2, BGS(31), ltoa(modChn[chn].vol), 5);
		FontPrint(0, 3, BGS(31), 
			"UP/DOWN FREQ:", 5);
		FontPrint(0, 4, BGS(31), 
			" B+UP/DOWN RVOL:", 5);
		if(chn >= 4)
		{
			FontPrint(19, 3, BGS(31), ltoa(0), 5);
			FontPrint(19, 4, BGS(31), ltoa(sndChn[chn - 4].rVol), 5);
		}
		else
		{
			FontPrint(19, 3, BGS(31), ltoa(modChn[chn].inc), 5);
			FontPrint(19, 4, BGS(31), ltoa(0), 5);
		}
		FontPrint(0, 5, BGS(31), "L/R SAMPLE:", 5);
		FontPrint(19, 6, BGS(31), ltoa(samp), 5);
		FontPrint(0, 7, BGS(31), "A TOGGLE CHN", 5);
		FontPrint(0, 8, BGS(31), "B+A TOGGLE LOOP", 5);
		FontPrint(0, 9, BGS(31), "START TOGGLE SONG", 5);
		for(i = 0; i < 4; i++)
		{
			FontPrint(0, 11 + i, BGS(31), ltoa(((u32*)0x2000000)[i]), 5);
			FontPrint(15, 11 + i, BGS(31), ltoa(((u32*)0x2000010)[i]), 5);
		}
		frame++;
	}

	return 0;
}
