#ifndef MATH_H
#define MATH_H

#include "main.h"

#define FP 16
#define i2f(x) ((x) << FP)
#define f2i(x) ((x) >> FP)
#define float2fp(x) ((s32)(((double)(x)) * (1 << FP)))
#define fp2float(x) (((double)(x)) / (1 << FP))
#define abs(x) ((x) < 0 ? -(x) : (x))
#define min(x, y)	((x) < (y) ? (x) : (y))
#define max(x, y)	((x) > (y) ? (x) : (y))

extern u32 sqrt(u32);	//BIOS sqrt
extern u32 isqrt(u32);	//faster sqrt from Kevin Weatherman
extern s32 div(s32, s32);
extern s32 divmod(s32, s32, s32*);
extern s32 mod(s32, s32);
extern s32 fpMul(s32, s32);
extern s32 fpMulX(s32, s32, u32);	//same, but specify fp bits
extern s32 fpDiv(s32, s32);
extern s32 Rcp(s32);

#endif
