.global SoftReset
.thumb
.align 2
.thumb_func
SoftReset:
swi 0x0

.global sqrt
.thumb
.align 2
.thumb_func
sqrt:
swi 0x8
bx lr

.global div
.thumb
.align 2
.thumb_func
div:
swi 0x6
bx lr

.global mod
.thumb
.align 2
.thumb_func
mod:
swi 0x6
mov r0, r1
bx lr

.global divmod
.thumb
.align 2
.thumb_func
divmod:
swi 0x6
str r1, [r2]
bx lr

.global fpMul
.arm
.align 4
fpMul:
smull r2, r0, r1, r0
mov r2, r2, LSR #16
orr r0, r2, r0, LSL #16
bx lr

.global fpMulX
.arm
.align 4
fpMulX:
smull r3, r0, r1, r0
mov r3, r3, LSR r2
rsb r2, r2, #32
orr r0, r3, r0, LSL r2
bx lr

.global fpDiv
.thumb
.align 2
.thumb_func
fpDiv:
lsr r1, r1, #8
swi 0x6
lsl r0, r0, #8
bx lr

.global Rcp
.arm
.align 4
Rcp:
cmp r0, #0
rsblt r0, r0, #0
mov r1, r0, LSR #16
sub r0, r0, r1, LSL #16
ldr r3, rcp_table
ldr r3, [r3]
ldr r2, [r3, r1, LSL #2]!
ldr r3, [r3, #4]
sub r3, r3, r2
mov r1, r2, LSL #16
mov r2, r2, LSR #16
smlal r1, r2, r0, r3
mov r0, r1, LSR #16
orr r0, r0, r2, LSL #16
rsblt r0, r0, #0
bx lr
rcp_table:
.word rcpTable

.global isqrt
.arm
.align 4
isqrt:
mov r1, #(3 << 30)
mov r2, #(1 << 30)

cmp r0, r2
subhs r0, r0, r2
adc r1, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 1)
subhs r0, r0, r2, LSL #(2 * 1)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 2)
subhs r0, r0, r2, LSL #(2 * 2)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 3)
subhs r0, r0, r2, LSL #(2 * 3)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 4)
subhs r0, r0, r2, LSL #(2 * 4)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 5)
subhs r0, r0, r2, LSL #(2 * 5)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 6)
subhs r0, r0, r2, LSL #(2 * 6)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 7)
subhs r0, r0, r2, LSL #(2 * 7)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 8)
subhs r0, r0, r2, LSL #(2 * 8)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 9)
subhs r0, r0, r2, LSL #(2 * 9)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 10)
subhs r0, r0, r2, LSL #(2 * 10)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 11)
subhs r0, r0, r2, LSL #(2 * 11)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 12)
subhs r0, r0, r2, LSL #(2 * 12)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 13)
subhs r0, r0, r2, LSL #(2 * 13)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 14)
subhs r0, r0, r2, LSL #(2 * 14)
adc r2, r1, r2, LSL #1

cmp r0, r2, LSL #(2 * 15)
subhs r0, r0, r2, LSL #(2 * 15)
adc r2, r1, r2, LSL #1

bic r0, r2, #(3 << 30)

bx lr



.global VSync
.thumb
.align 2
.thumb_func
VSync:
swi 0x5
bx lr

.global CpuSet
.thumb
.align 2
.thumb_func
CpuSet:
swi 0xb
bx lr

.global CpuFastSet
.thumb
.align 2
.thumb_func
CpuFastSet:
swi 0xc
bx lr

.global BgAffineSet
.thumb
.align 2
.thumb_func
BgAffineSet:
swi 0xe
bx lr

.global ObjAffineSet
.thumb
.align 2
.thumb_func
ObjAffineSet:
swi 0xf
bx lr

.global UnCompLZ77WRam
.thumb
.align 2
.thumb_func
UnCompLZ77WRam:
swi 0x11
bx lr

.global UnCompLZ77VRam
.thumb
.align 2
.thumb_func
UnCompLZ77VRam:
swi 0x12
bx lr
