/*	//0-3=order, 4-5=snd vol for this side, 6-7=current mod chns, 
	//8-11=chn dist, 12-15=sample count stack, 
	//16=loop, 17=sample count stack idx, 18=end jump table, 
	//19=mixBufSize, 20=sndSong, 21=blankData, 
	//22=modChn, 23=sndChn, 24=mixBuf, 25=SndMixLoop, 
	//26=return from SndMixLoop, 27=main loop, 28=signAdjust, 29=chnEnd*/

.equ order,			0
.equ mod,			16
.equ sndVol,		24
.equ chnDist,		32
.equ sampCnt,		48
.equ ssIdx,			64
.equ endTable,		68
.equ mixBufSize,	72
.equ song,			76
.equ gVol,			80
.equ sndBlank,		84
.equ modCh,			88
.equ sndCh,			92
.equ mixBuf,		96
.equ mixLoop,		100
.equ mixLoopRtn,	104
.equ endTabRtn,	108
.equ mainLoop,		112
.equ sgnAdj,		116
.equ chnEnd,		120
.equ sFree,			124

.equ sndFp,			8
.equ sndBase,		0x8000000
.equ sndBaseBase,	8

.global SndMix
.thumb
.align 2
.thumb_func
SndMix:
	mov r0, r8
	mov r1, r9
	mov r2, r10
	mov r3, r11
	push {r0-r7, lr}

	sub sp, #128

	ldr r0, =sndEndTable
	ldr r1, =sndMixBufSize
	ldr r1, [r1]
	ldr r2, =pSndSong
	ldr r2, [r2]
	ldrb r3, [r2, #4]
	ldr r4, =dSndBlank
	ldr r5, =modChn
	ldr r6, =sndChn
	mov r7, sp
	add r7, r7, #endTable
	stmia r7!, {r0-r6}

	ldr r0, =sndCurMixBuf
	ldr r0, [r0]
	ldr r1, =SndMixLoop
	ldr r2, =snd_mix_end
	add r2, r2, #1
	ldr r3, =snd_mix_loop
	add r3, r3, #1
	mov r4, #2
	stmia r7!, {r0-r4}

	ldr r6, [sp, #sndCh]
	mov r7, sp
	mov r0, #0
	mov r1, #3
	mov r2, #4
	mov r3, #5
	stmia r7!, {r0-r3}
	ldr r4, [sp, #gVol]
	ldrb r2, [r6, #14]
	mul r2, r4
	ldrb r3, [r6, #30]
	mul r3, r4
	stmia r7!, {r0-r3}

snd_main_loop:

@@@ Init sndChn[0] @@@
	@ r5=temp sgnAdj, r11=temp chnEnd
	ldr r6, [sp, #mixBufSize]
	ldr r7, [sp, #sndCh]
	ldmia r7!, {r0-r3}	@r3 unused, sets pointer to chn[1]
	mov r12, r0
	add r12, r1
	sub r3, r2, r1
	cmp r3, r6
	ble sndChn0_end
	str r6, [sp, #(chnDist + 8)]
	mov r0, #0
	b sndChn0_noend
	sndChn0_end:
	str r3, [sp, #(chnDist + 8)]
	mov r0, #16
	sndChn0_noend:
	mov r11, r0
	ldr r5, [sp, #sndVol]

@@@ Init sndChn[1] @@@
	ldmia r7!, {r0-r2}
	mov r14, r0
	add r14, r1
	sub r3, r2, r1
	cmp r3, r6
	ble sndChn1_end
	str r6, [sp, #(chnDist + 12)]
	b sndChn1_noend
	sndChn1_end:
	str r3, [sp, #(chnDist + 12)]
	mov r0, #32
	add r11, r0
	sndChn1_noend:
	ldr r0, [sp, #(sndVol + 4)]
	add r5, r5, r0

@@@ Init modChn[mod[1]]
	ldr r7, [sp, #modCh]
	ldr r0, [sp, #(mod + 4)]
	lsl r1, r0, #1
	add r0, r0, r1
	lsl r0, r0, #3
	add r7, r7, r0
	ldmia r7!, {r0-r4}
	add r5, r5, r3
	mov r9, r2
	lsl r0, r0, #sndFp
	mov r8, r0
	add r8, r1
	ldr r0, [sp, #gVol]
	mul r3, r0
	mov r10, r3
	mul r2, r6
	sub r0, r4, r1
	cmp r0, r2
	ble modChn1_end
	str r6, [sp, #(chnDist + 4)]
	b modChn1_noend
	modChn1_end:
	mov r1, r9
	swi 6
	str r0, [sp, #(chnDist + 4)]
	ldr r0, [sp, #(mod + 4)]
	mov r1, #1
	lsl r1, r1, r0
	add r11, r1
	modChn1_noend:

@@@ Init modChn[mod[0]]
	ldr r7, [sp, #modCh]
	ldr r0, [sp, #mod]
	lsl r1, r0, #1
	add r0, r0, r1
	lsl r0, r0, #3
	add r7, r7, r0
	ldmia r7!, {r0-r4}
	ldr r7, [sp, #gVol]
	mul r3, r7
	add r5, r5, r3
	lsl r5, r5, #7
	neg r5, r5
	str r5, [sp, #sgnAdj]
	mov r7, r3
	lsl r5, r0, #sndFp
	add r5, r5, r1
	str r6, [sp, #chnDist]	@so we can overwrite r6
	mul r6, r2
	sub r0, r4, r1
	cmp r0, r6
	bgt modChn0_noend
	mov r6, r2
	mov r1, r2
	swi 6
	str r0, [sp, #chnDist]
	ldr r0, [sp, #mod]
	mov r1, #1
	lsl r1, r1, r0
	add r11, r1
	b modChn0_end
	modChn0_noend:
	mov r6, r2
	modChn0_end:
	mov r0, r11
	str r0, [sp, #chnEnd]

/*	mov r4, sp
	add r4, r4, #chnDist
	mov r0, #0
	str r0, [sp, #sFree]
	add r1, r0, #4
	snd_sort_loop:
	ldr r2, [r4, r1]
	ldr r3, [r4, r0]
	cmp r2, r3
	ble snd_sort_loop_noset
	mov r0, r1
	snd_sort_loop_noset:
	add r1, r1, #4
	cmp r1, #16
	blt snd_sort_loop
	ldr r1, [sp, #sFree]
	cmp r0, r1
	beq snd_sort_loop_check
	ldr r2, [r4, #12]	@swap dist
	ldr r3, [r4, r0]
	str r2, [r4, r0]	@swap dist
	str r3, [r4, #12]
	sub r4, r4, #(chnDist - order)
	ldr r2, [r4, #12]	@swap order
	ldr r3, [r4, r0]
	str r2, [r4, r0]
	str r3, [r4, #12]
	add r4, r4, #(chnDist - order)
	snd_sort_loop_check:
	add r0, r1, #4
	str r0, [sp, #sFree]
	add r1, r0, #4
	cmp r0, #12
	blt snd_sort_loop
*/
	add r0, sp, #chnDist
	mov r1, #16
	chan_sort_loop:
	sub r1, #4
	bmi chan_sort_end
	mov r4, #16
	chan_sort_loop_inner:
	sub r4, #4
	bmi chan_sort_loop
	chan_sort_loop_inner2:
	ldr r3, [r0, r4]
	ldr r2, [r0, r1]
	cmp r2, r3
	bge chan_sort_loop_inner
	str r2, [r0, r4]
	str r3, [r0, r1]
	sub r0, r0, #chnDist
	ldr r3, [r0, r4]
	ldr r2, [r0, r1]
	str r2, [r0, r4]
	str r3, [r0, r1]
	add r0, r0, #chnDist
	sub r4, #4
	bmi chan_sort_loop
	b chan_sort_loop_inner2
	chan_sort_end:

	ldr r0, [sp, #(chnDist + 12)]
	str r0, [sp, #(sampCnt + 12)]
	ldr r1, [sp, #(chnDist + 8)]
	sub r0, r1, r0
	str r0, [sp, #(sampCnt + 8)]
	ldr r0, [sp, #(chnDist + 4)]
	sub r1, r0, r1
	str r1, [sp, #(sampCnt + 4)]
	ldr r1, [sp, #chnDist]
	sub r0, r1, r0
	str r0, [sp, #sampCnt]

	mov r0, sp
	add r0, r0, #chnDist
	ldmia r0!, {r1-r4}
	mov r0, #2
	lsl r0, r0, #24
	stmia r0!, {r1-r4}

	mov r0, sp
	add r0, r0, #sampCnt
	ldmia r0!, {r1-r4}
	mov r0, #2
	lsl r0, r0, #24
	add r0, r0, #16
	stmia r0!, {r1-r4}

	mov r0, sp
	ldr r3, [sp, #mixBuf]
	ldr r1, [sp, #sndVol]
	mov r11, r1
	ldr r1, [sp, #(sndVol + 4)]
	mov r13, r1
	mov r1, #16

	snd_mix_loop:
	sub r1, r1, #4
	str r1, [r0, #ssIdx]
	bpl snd_noblank
	ldr r2, [r0, #mixBufSize]
	ldr r1, [r0, #chnDist]
	sub r2, r2, r1
	sub r2, r2, #1
	ble snd_end
	mov r1, #0
	snd_blank_loop:
	strb r1, [r3, r2]
	sub r2, r2, #1
	bpl snd_blank_loop
	b snd_end

	snd_noblank:
	add r2, r1, r0
	ldr r2, [r2, #sampCnt]
	cmp r2, #0
	ble snd_mix_end
	ldr r4, [r0, #sgnAdj]
	ldr r1, [r0, #mixLoop]
	bx r1

	snd_mix_end:
	ldr r1, [r0, #ssIdx]
	ldr r4, [r0, r1]
	ldr r2, [r0, #chnEnd]
	lsr r2, r4
	lsr r2, r2, #1
	bcc snd_mix_loop
	ldr r2, [r0, #song]
	ldr r2, [r2]
	lsr r2, r4
	lsr r2, r2, #9
	bcc mix_end_noloop
	add r4, r4, #6
	mix_end_noloop:
	lsl r4, r4, #2
	ldr r2, [r0, #endTable]
	ldr r2, [r2, r4]
	bx r2

	snd_end:
	mov r6, #4

	mod_end_loop:
	add r1, r6, r0
	add r1, r1, #mod
	ldr r2, [r1]
	ldr r1, [r0, #song]
	ldr r1, [r1]
	lsr r1, r2

	ldr r5, [r0, #modCh]
	lsl r4, r2, #1
	add r4, r4, r2
	lsl r4, r4, #3
	add r5, r5, r4

	lsr r4, r1, #1
	bcc mod_end_inactive
	ldr r4, [r0, #chnEnd]
	lsr r4, r2
	lsr r4, r4, #1
	bcc mod_end_noend
	lsr r4, r1, #9
	bcc mod_end_noloop

	ldr r1, [r5, #4]
	ldr r2, [r5, #8]
	ldr r3, [r0, #mixBufSize]
	mul r2, r3
	add r1, r1, r2
	ldr r2, [r5, #20]
	sub r1, r1, r2
	str r1, [r5, #4]
	b mod_end_inactive

	mod_end_noloop:
	mov r1, #1
	lsl r1, #8
	add r1, r1, #1
	lsl r3, r1, #16
	orr r1, r3
	lsl r1, r2
	ldr r4, [r0, #song]
	ldr r3, [r4]
	bic r3, r1
	str r3, [r4]
	ldr r1, [r0, #sndBlank]
	str r1, [r5]
	mov r1, #0
	str r1, [r5, #4]
	str r1, [r5, #8]
	str r1, [r5, #12]
	ldr r1, [r0, #mixBufSize]
	add r1, r1, #1
	lsl r1, r1, #sndFp
	str r1, [r5, #16]
	b mod_end_inactive

	mod_end_noend:
	ldr r1, [r5, #4]
	ldr r2, [r5, #8]
	ldr r3, [r0, #mixBufSize]
	mul r2, r3
	add r1, r1, r2
	str r1, [r5, #4]
	mod_end_inactive:
	sub r6, r6, #4
	bpl mod_end_loop

	mov sp, r0

	ldr r0, [sp, #mainLoop]
	sub r0, #1
	beq snd_main_loop_end
	str r0, [sp, #mainLoop]

	ldr r6, [sp, #sndCh]
	mov r7, sp
	mov r1, #1
	mov r2, #2
	mov r3, #4
	mov r4, #5
	stmia r7!, {r1-r4}
	ldr r5, [sp, #gVol]
	ldrb r3, [r6, #15]
	mul r3, r5
	ldrb r4, [r6, #31]
	mul r4, r5
	stmia r7!, {r1-r4}

	ldr r1, [sp, #mixBuf]
	ldr r2, [sp, #mixBufSize]
	lsl r2, r2, #1
	add r1, r1, r2
	str r1, [sp, #mixBuf]

	b snd_main_loop

	snd_main_loop_end:

	mov r6, #16
	mov r2, #5

	snd_end_loop:
	ldr r1, [sp, #song]
	ldr r1, [r1]
	lsr r1, r2

	ldr r5, [sp, #sndCh]
	add r5, r5, r6

	lsr r4, r1, #1
	bcc snd_end_inactive
	ldr r4, [sp, #chnEnd]
	lsr r4, r2
	lsr r4, r4, #1
	bcc snd_end_noend
	lsr r1, r1, #9
	bcc snd_end_noloop

	ldr r1, [r5, #4]
	ldr r3, [sp, #mixBufSize]
	add r1, r1, r3
	ldrh r3, [r5, #12]
	sub r1, r1, r3
	str r1, [r5, #4]
	b snd_end_inactive

	snd_end_noloop:
	mov r1, #1
	lsl r1, #8
	add r1, r1, #1
	lsl r1, r2
	ldr r4, [sp, #song]
	ldr r3, [r4]
	bic r3, r1
	str r3, [r4]
	ldr r1, [sp, #sndBlank]
	str r1, [r5]
	mov r1, #0
	str r1, [r5, #4]
	strh r1, [r5, #14]
	ldr r1, [sp, #mixBufSize]
	add r1, r1, #1
	str r1, [r5, #8]
	b snd_end_inactive

	snd_end_noend:
	ldr r1, [r5, #4]
	ldr r3, [sp, #mixBufSize]
	add r1, r1, r3
	str r1, [r5, #4]
	snd_end_inactive:
	sub r2, r2, #1
	sub r6, r6, #16
	bpl snd_end_loop

	snd_return:

	add sp, #128

	pop {r0-r7}
	mov r8, r0
	mov r9, r1
	mov r10, r2
	mov r11, r3
	pop {r0}
	bx r0

.global Snd0EndNoLoop
.thumb
.align 2
.thumb_func
Snd0EndNoLoop:
ldr r2, [r0, #sndBlank]
mov r12, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Snd0EndLoop
.thumb
.align 2
.thumb_func
Snd0EndLoop:
ldr r2, [r0, #sndCh]
ldrh r2, [r2, #12]
neg r2, r2
add r12, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Snd1EndNoLoop
.thumb
.align 2
.thumb_func
Snd1EndNoLoop:
ldr r2, [r0, #sndBlank]
mov r14, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Snd1EndLoop
.thumb
.align 2
.thumb_func
Snd1EndLoop:
ldr r2, [r0, #sndCh]
ldrh r2, [r2, #28]
neg r2, r2
add r14, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod01EndNoLoop
.thumb
.align 2
.thumb_func
Mod01EndNoLoop:
ldr r2, [r0, #sndBlank]
lsl r5, r2, #sndFp
mov r6, #0
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod23EndNoLoop
.thumb
.align 2
.thumb_func
Mod23EndNoLoop:
ldr r2, [r0, #sndBlank]
lsl r2, r2, #sndFp
mov r8, r2
mov r2, #0
mov r9, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod0EndLoop
.thumb
.align 2
.thumb_func
Mod0EndLoop:
ldr r2, [r0, #modCh]
ldr r2, [r2, #20]
sub r5, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod1EndLoop
.thumb
.align 2
.thumb_func
Mod1EndLoop:
ldr r2, [r0, #modCh]
ldr r2, [r2, #44]
sub r5, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod2EndLoop
.thumb
.align 2
.thumb_func
Mod2EndLoop:
ldr r2, [r0, #modCh]
ldr r2, [r2, #68]
neg r2, r2
add r8, r2
ldr r2, [r0, #endTabRtn]
bx r2

.global Mod3EndLoop
.thumb
.align 2
.thumb_func
Mod3EndLoop:
ldr r2, [r0, #modCh]
ldr r2, [r2, #92]
neg r2, r2
add r8, r2
ldr r2, [r0, #endTabRtn]
bx r2
