#include "main.h"

void SndSongPlay(u8 *data, u8 order, u8 row)
{
	u32 i, j;

	if(data != pSndSong->songData || !(pSndSong->state & SND_STATE_PLAY))
	{
		REG_IME = 0;

		pSndSong->songData = data;
		pSndSong->len = *data++;
		pSndSong->chnCnt = *data++;
		pSndSong->patCnt = *data++;
		pSndSong->sampCnt = *data++;
		pSndSong->order = data;
		data += (pSndSong->len + 3) & ~3;
		pSndSong->samp = (pSample)(data - sizeof(Sample));
		data += sizeof(Sample) * pSndSong->sampCnt;
		pSndSong->patOffset = (u16*)data;
		data += ((pSndSong->patCnt + 1) >> 1) << 2;
		pSndSong->patData = data;
		pSndSong->patDelay = 0;
		pSndSong->spd = 6;
		pSndSong->tick = 6 << 8;
		pSndSong->bpm = 125;
		pSndSong->vol = 128;
		pSndSong->state = (pSndSong->state & 3) | SND_STATE_PLAY;
		j = 0;
		Dma3(pSndSong->chnPeriod, &j, (SND_CHANNELS * 15) >> 2, DMA_MEMSET32);
		pSndSong->chnActive &= ~0x0f0f0f0f;
		SndSongSeek(order, row);

		REG_IME = 1;
	}
}

void SndSongPause(u32 pause)
{
	u32 i;
	if(pause)
	{
		pSndSong->state |= SND_STATE_PAUSE;
		for(i = 0; i < SND_CHANNELS; i++)
		{
			pSndSong->chnActive &= ~0xf;
		}
	}
	else
	{
		pSndSong->state &= ~SND_STATE_PAUSE;
	}
}

void SndSongStop()
{
	u32 i;
	pSndSong->state &= ~SND_STATE_PLAY;
	for(i = 0; i < pSndSong->chnCnt; i++)
		pSndSong->chnActive &= ~0x0f0f0f0f;
}

void SndSongSeek(u8 order, u8 row)
{
	u8 flagByte, rowLen;
	pSndSong->pos = order;
	if(pSndSong->pos >= pSndSong->len)
		pSndSong->pos = pSndSong->len - 1;
	pSndSong->curRow = 0;
	pSndSong->rowPtr = pSndSong->patData + 
		pSndSong->patOffset[pSndSong->order[pSndSong->pos]];
	pSndSong->rowPtr += row * 3 * 4;
/*	while(pSndSong->curRow < row)
	{
		rowLen = 0;
		flagByte = 1;
		while(flagByte != 0 && rowLen < pSndSong->chnCnt)
		{
			flagByte = *pSndSong->rowPtr++;
			if(flagByte != 0)
			{
				rowLen++;
				if((flagByte & 0xc0) == BIT06)
					pSndSong->rowPtr += 2;
				if((flagByte & 0xc0) == BIT07)
				{
					if((pSndSong->rowPtr[0] & 0xf) == 0xf)
					{
						if(pSndSong->rowPtr[1] < 0x10)
							pSndSong->spd = pSndSong->rowPtr[1];
						else
							pSndSong->bpm = pSndSong->rowPtr[1];
					}
					pSndSong->rowPtr += 2;
				}
				else
				{
					if((pSndSong->rowPtr[1] & 0xf0) == 0xf0)
					{
						if(pSndSong->rowPtr[2] < 0x10)
							pSndSong->spd = pSndSong->rowPtr[2];
						else
							pSndSong->bpm = pSndSong->rowPtr[2];
					}
					pSndSong->rowPtr += 3;
				}
			}
		}
		pSndSong->curRow++;
	}*/
	pSndSong->incTick = div((u32)pSndSong->bpm << 24, 9785671);
}

void SndSongUpdate()
{
	u32 i, j, k;
	u8 *notePtr, flagByte;

	if((pSndSong->state & (3 << 2)) == SND_STATE_PLAY)
	{
		pSndSong->tick += pSndSong->incTick;
		if((pSndSong->tick >> 8) >= pSndSong->spd)
		{
			pSndSong->tick = mod(pSndSong->tick, pSndSong->spd << 8);
			if(pSndSong->patDelay > 0)
				pSndSong->patDelay--;
			else
			{
				if(++pSndSong->curRow >= 64)
				{
					if(++pSndSong->pos >= pSndSong->len)
					{
						pSndSong->state &= ~SND_STATE_PLAY;
						return;
					}
					pSndSong->curRow = 0;
					pSndSong->rowPtr = pSndSong->patData + 
						pSndSong->patOffset[pSndSong->order[pSndSong->pos]];
				}
				else
				{
					if(pSndSong->patLoopCnt > 0)
					{
						pSndSong->patLoopCnt--;
						SndSongSeek(pSndSong->pos, pSndSong->patLoopRow);
					}
				}
				for(i = 0; i < pSndSong->chnCnt; i++)
				{
					u8 periodChange = 0;
					flagByte = 0;
					notePtr = pSndSong->rowPtr;
					if((notePtr[0] & 0x7f) != 0)
					{
						pSndSong->chnNote[i] = notePtr[0] & 0x7f;
						flagByte |= BIT00;
					}
					j = ((notePtr[0] >> 7) & 1) | 
						((notePtr[1] & 0xf) << 1);
					if(j != 0)
					{
						pSndSong->chnSamp[i] = j;
						flagByte |= BIT01;
					}
					if(((notePtr[1] >> 4) != 0) || (notePtr[2] != 0))
					{
						pSndSong->chnEffect[i] = notePtr[1] >> 4;
						pSndSong->chnParam[i] = notePtr[2];
						flagByte |= BIT02;
					}
					if(flagByte & BIT00)
					{
						if(flagByte & BIT02)
						{
							if((pSndSong->chnEffect[i] == 4 || 
								pSndSong->chnEffect[i] == 6) && 
								!(pSndSong->chnFxFlags[i] & (1 << 5)))	//vibrato retrig
							{
								pSndSong->chnActive &= ~(0x1000000 << i);	//neg flag
								pSndSong->chnFxPos[i] = 0;
								modChn[i].pos = 0;
							}
							else if(pSndSong->chnEffect[i] == 7 && 
								!(pSndSong->chnFxFlags[i] & (1 << 2)))	//tremolo retrig
							{
								pSndSong->chnActive &= ~(0x1000000 << i);	//neg flag
								pSndSong->chnFxPos[i] = 0;
								modChn[i].pos = 0;
								pSndSong->chnFxTemp[i] = pSndSong->chnVol[i];
							}
						}
						pSndSong->chnPeriod[i] = 
							sndPeriodTable[(pSndSong->chnNote[i] & 0xf) + 
							(pSndSong->samp[pSndSong->chnSamp[i]].tune << 4)] >> 
							(pSndSong->chnNote[i] >> 4);
						periodChange = 1;
						if(pSndSong->samp[pSndSong->chnSamp[i]].volLoop & BIT07)
							pSndSong->chnActive |= 0x100 << i;
					}
					if(flagByte & BIT01)
						pSndSong->chnVol[i] = pSndSong->samp[j].volLoop & 127;
					if(flagByte & BIT02)
					{
						j = pSndSong->chnEffect[i];
						if((j == 3 || j == 5) && 
							pSndSong->chnParam[i] != 0)	//porta
						{
							pSndSong->chnPortaSpd[i] = pSndSong->chnParam[i];
							if(j == 3 && (flagByte & BIT00))
								pSndSong->chnFxTemp[i] = pSndSong->chnNote[i];
						}
						else if((j == 4 || j == 6) && pSndSong->chnParam[i] != 0)	//vibrato
						{
							pSndSong->chnVibratoSpd[i] = pSndSong->chnParam[i];
							pSndSong->chnFxTemp[i] = pSndSong->chnPeriod[i];
						}
						else if(j == 7 && pSndSong->chnParam[i] != 0)	//tremolo
						{
							pSndSong->chnTremoloSpd[i] = pSndSong->chnParam[i];
						}
						else if(j == 8 && pSndSong->chnParam[i] != 0)	//panning
						{
							pSndSong->chnPan[i] = pSndSong->chnParam[i];
						}
						else if(j == 0xB)	//position jump
							SndSongSeek(pSndSong->chnParam[i], 0);
						else if(j == 0xC)
							pSndSong->chnVol[i] = pSndSong->chnParam[i];
						else if(j == 0xD)	//pattern break
						{
							if(++pSndSong->pos >= pSndSong->len)
								pSndSong->pos = 0;
							SndSongSeek(pSndSong->pos, pSndSong->chnParam[i]);
						}
						else if(j == 0xE)
						{
							j = pSndSong->chnParam[i];
							if(j >> 4 == 1)	//fine porta up
							{
								pSndSong->chnPeriod[i] -= pSndSong->chnParam[i];
								periodChange = 1;
							}
							else if(j >> 4 == 2)	//fine porta down
							{
								pSndSong->chnPeriod[i] += pSndSong->chnParam[i];
								periodChange = 1;
							}
							else if(j >> 4 == 3)	//glissando (unsupported)
								pSndSong->chnFxFlags[i] ^= BIT07;
							else if(j >> 4 == 4)	//vibrato wave
								pSndSong->chnFxFlags[i] = (pSndSong->chnFxFlags[i] & 0x7) | 
								(pSndSong->chnParam[i] & 0x7);
							else if(j >> 4 == 5)	//finetune
							{
								pSndSong->chnPeriod[i] = sndPeriodTable
									[(pSndSong->chnNote[i] & 0xf) + 
									(pSndSong->chnParam[i] << 4)] >> 
									(pSndSong->chnNote[i] >> 4);
								periodChange = 1;
							}
							else if(j >> 4 == 6)	//pattern loop
							{
								if((j & 0xf) == 0)
									pSndSong->chnPatLoopRow[i] = pSndSong->curRow;
								else if(pSndSong->patLoopCnt == 0)
								{
									pSndSong->patLoopRow = pSndSong->chnPatLoopRow[i];
									pSndSong->patLoopCnt = j & 0xf;
								}
							}
							else if(j >> 4 == 7)	//tremolo wave
								pSndSong->chnFxFlags[i] = 
									(pSndSong->chnFxFlags[i] & ~(0x7 << 3)) | 
									((pSndSong->chnParam[i] & 0x7) << 3);
							else if(j >> 4 == 8)	//panning (effect 8 is better)
								pSndSong->chnPan[i] = 
									(pSndSong->chnParam[i] & 0xf) << 3;
							else if(j >> 4 == 0xA)
								pSndSong->chnVol[i] += j & 0xf;
							else if(j >> 4 == 0xB)
								pSndSong->chnVol[i] -= j & 0xf;
							else if(j >> 4 == 0xC)	//note cut
								pSndSong->chnFxTemp[i] = j & 0xf;
							else if(j >> 4 == 0xD)	//note delay
								pSndSong->patDelay = j & 0xf;
							else if(j >> 4 == 0xE)	//pattern delay
								pSndSong->patDelay = j & 0xf;
						}
						else if(j == 0xF)	//speed/tempo
						{
							if(pSndSong->chnParam[i] <= 0x1F)
								pSndSong->spd = pSndSong->chnParam[i];
							else
							{
								pSndSong->bpm = pSndSong->chnParam[i];
								pSndSong->incTick = div((u32)pSndSong->bpm << 24, 
									9785671);
							}
						}
					}
					if(pSndSong->chnVol[i] > 64)
						pSndSong->chnVol[i] = 64;
					if(!(pSndSong->chnActive & (0x10000 << i)))
					{
						u16 tempPeriod = pSndSong->chnPeriod[i], 
							tempVol = pSndSong->chnVol[i];

						if(flagByte & BIT00)
						{
							if((flagByte & BIT02) && 
								(pSndSong->chnEffect[i] == 9))	//offset
									modChn[i].pos = (u32)pSndSong->chnParam[i] << 9;
							else
								modChn[i].pos = 0;
							j = pSndSong->samp[pSndSong->chnSamp[i]].sndIdx;
							modChn[i].data = dSndTable[j];
							modChn[i].len = dSndLength[j] << 8;
							modChn[i].loopLen = dSndLoop[j] << 8;
							pSndSong->chnActive |= 1 << i;
							if(pSndSong->samp[pSndSong->chnSamp[i]].volLoop & BIT07)
								pSndSong->chnActive |= 0x100 << i;
							else
								pSndSong->chnActive &= ~(0x100 << i);
						}
						if(flagByte & BIT02)
						{
							if((pSndSong->chnEffect[i] == 4) || 
								(pSndSong->chnEffect[i] == 6))
							{
								j = ((u32)(sndSineTable[pSndSong->chnFxPos[i]]) * 
									(pSndSong->chnVibratoSpd[i] & 0xf)) >> 7;
								if(pSndSong->chnActive & (0x1000000 << i))
									tempPeriod -= j;
								else
									tempPeriod += j;
								periodChange = 1;
							}
							if(pSndSong->chnEffect[i] == 7)
							{
								j = ((u32)(sndSineTable[pSndSong->chnFxPos[i]]) * 
									(pSndSong->chnTremoloSpd[i] & 0xf)) >> 7;
								if(pSndSong->chnActive & (0x1000000 << i))
								{
									if(tempVol > j)
										tempVol -= j;
									else
										tempVol = 0;
								}
								else if(tempVol + j <= 64)
									tempVol += j;
								else
									tempVol = 64;
							}
						}
						modChn[i].vol = tempVol;
						if(periodChange)
							modChn[i].inc = div(dSndFreq[pSndSong->samp
								[pSndSong->chnSamp[i]].sndIdx] * (428 << 8), 
								(tempPeriod == 0 ? 1 : tempPeriod) * sndFreq);
					}
					pSndSong->rowPtr += 3;
				} 
			}
		}
		else
		{
			for(i = 0; i < pSndSong->chnCnt; i++)
			{
				u8 periodChange = 0;
				j = pSndSong->chnEffect[i];
				if((j == 0) && (pSndSong->chnParam[i] != 0))	//arpeggio
				{
					j = mod(pSndSong->tick >> 8, 3);
					if(j == 1)
						j = pSndSong->chnParam[i] >> 4;
					else if(j == 2)
						j = pSndSong->chnParam[i] & 0xf;
					else
						j = 0;
					pSndSong->chnPeriod[i] = 
						sndPeriodTable[(pSndSong->chnNote[i] & 0xf) + 
						(j << 4)] >> (pSndSong->chnNote[i] >> 4);
					periodChange = 1;
				}
				else if(j == 1)	//porta up
				{
					pSndSong->chnPeriod[i] -= pSndSong->chnPortaSpd[i];
					periodChange = 1;
				}
				else if(j == 2)	//porta down
				{
					pSndSong->chnPeriod[i] += pSndSong->chnPortaSpd[i];
					periodChange = 1;
				}
				else if(j == 3 || j == 5)	//porta to note
				{
					if(pSndSong->chnFxTemp[i] > pSndSong->chnNote[i])
					{
						if(pSndSong->chnPeriod[i] > 
							(sndPeriodTable[pSndSong->chnFxTemp[i] & 0xf] >> 
							pSndSong->chnFxTemp[i] >> 4))
						{
							pSndSong->chnPeriod[i] -= pSndSong->chnPortaSpd[i];
							periodChange = 1;
						}
					}
					else
					{
						if(pSndSong->chnPeriod[i] < 
							(sndPeriodTable[pSndSong->chnFxTemp[i] & 0xf] >> 
							pSndSong->chnFxTemp[i] >> 4))
						{
							pSndSong->chnPeriod[i] += pSndSong->chnPortaSpd[i];
							periodChange = 1;
						}
					}
				}
				else if(j == 4 || j == 6)	//vibrato
				{
					pSndSong->chnFxPos[i] += pSndSong->chnVibratoSpd[i] >> 4;
					if(pSndSong->chnFxPos[i] > 31)
					{
						pSndSong->chnFxPos[i] -= 32;
						pSndSong->chnActive ^= (0x1000000 << i);
					}
				}
				else if(j == 7)
				{
					pSndSong->chnFxPos[i] += pSndSong->chnTremoloSpd[i] >> 4;
					if(pSndSong->chnFxPos[i] > 31)
					{
						pSndSong->chnFxPos[i] -= 32;
						pSndSong->chnActive ^= (0x1000000 << i);
					}
				}
				else if(j == 0xE)
				{
					j = pSndSong->chnParam[i];
					if((j >> 4 == 0xC) && ((pSndSong->tick >> 8) >= 
						(pSndSong->chnParam[i] & 0xf)))	//note cut
						pSndSong->chnVol[i] = 0;
					else if((j >> 4 == 0xD) && ((pSndSong->tick >> 8) >= 
						(pSndSong->chnParam[i] & 0xf)))	//note delay
					{
						pSndSong->chnPeriod[i] = sndPeriodTable
							[pSndSong->chnNote[i] & 0xf] >> 
							(pSndSong->chnNote[i] >> 4);
						pSndSong->chnVol[i] = pSndSong->samp
							[pSndSong->chnSamp[i]].volLoop & 127;
						periodChange = 1;
					}
				}
				j = pSndSong->chnEffect[i];	//incase an effect changed j
				if(j == 5 || j == 6 || j == 0xA)	//volSlide
				{
					j = pSndSong->chnParam[i];
					if((j & 0xf) > 0)
					{
						if((j >> 4) == 0)
							pSndSong->chnVol[i] -= j & 0xf;
					}
					else if((j >> 4) > 0)
						pSndSong->chnVol[i] += j >> 4;
				}
				if(pSndSong->chnVol[i] > 64)
					pSndSong->chnVol[i] = 64;
				if(!(pSndSong->chnActive & (0x10000 << i)))
				{
					u16 tempPeriod = pSndSong->chnPeriod[i], 
						tempVol = pSndSong->chnVol[i];

					if((pSndSong->chnEffect[i] == 4) || 
						(pSndSong->chnEffect[i] == 6))
					{
						j = ((u32)(sndSineTable[pSndSong->chnFxPos[i]]) * 
							(pSndSong->chnVibratoSpd[i] & 0xf)) >> 7;
						if(pSndSong->chnActive & (0x1000000 << i))
							tempPeriod -= j;
						else
							tempPeriod += j;
						periodChange = 1;
					}
					else if(pSndSong->chnEffect[i] == 7)
					{
						j = ((u32)(sndSineTable[pSndSong->chnFxPos[i]]) * 
							(pSndSong->chnTremoloSpd[i] & 0xf)) >> 7;
						if(pSndSong->chnActive & (0x1000000 << i))
						{
							if(tempVol > j)
								tempVol -= j;
							else
								tempVol = 0;
						}
						else if(tempVol + j <= 64)
							tempVol += j;
						else
							tempVol = 64;
					}
					else if((pSndSong->chnEffect[i]) == 0xE)
					{
						if(((pSndSong->chnParam[i] >> 4) == 9) && 
							((pSndSong->tick >> 8) >= 
							(pSndSong->chnParam[i] & 0xf)))	//retrig
						{
							modChn[i].pos = 0;
							pSndSong->chnActive |= 1 << i;
						}
						else if((pSndSong->chnParam[i] >> 4) == 0xD && 
							!mod(pSndSong->tick >> 8, 
							pSndSong->chnParam[i] & 0xf))	//delay
						{
							j = pSndSong->samp[pSndSong->chnSamp[i]].sndIdx;
							modChn[i].data = dSndTable[j];
							modChn[i].pos = 0;
							modChn[i].len = dSndLength[j] << 8;
							modChn[i].loopLen = dSndLoop[j] << 8;
							pSndSong->chnActive |= 1 << i;
							if(pSndSong->samp[pSndSong->chnSamp[i]].volLoop & BIT07)
								pSndSong->chnActive |= 0x100 << i;
						}
					}
					modChn[i].vol = tempVol;
					if(periodChange)
						modChn[i].inc = div(dSndFreq[pSndSong->samp
							[pSndSong->chnSamp[i]].sndIdx] * (428 << 8), 
							(tempPeriod == 0 ? 1 : tempPeriod) * sndFreq);
				}
			}
		}
	}
}

const u16 sndPeriodTable[] = {
//	C   C#  D   D#  E   F   F#  G   G#  A   A#  B
	1712, 1616, 1524, 1440, 1356, 1280, 1208, 1140, 1076, 1016, 960, 904, 0, 0, 0, 0, 
	1700, 1604, 1516, 1428, 1348, 1272, 1200, 1136, 1072, 1012, 956, 900, 0, 0, 0, 0, 
	1688, 1592, 1504, 1420, 1340, 1264, 1192, 1128, 1064, 1004, 948, 896, 0, 0, 0, 0, 
	1676, 1580, 1492, 1408, 1328, 1256, 1184, 1120, 1056, 996, 940, 888, 0, 0, 0, 0, 
	1664, 1568, 1480, 1400, 1320, 1248, 1176, 1112, 1048, 988, 932, 880, 0, 0, 0, 0, 
	1652, 1560, 1472, 1388, 1312, 1236, 1168, 1104, 1040, 980, 928, 876, 0, 0, 0, 0, 
	1640, 1548, 1460, 1380, 1300, 1228, 1160, 1096, 1032, 976, 920, 868, 0, 0, 0, 0, 
	1628, 1536, 1452, 1368, 1292, 1220, 1152, 1088, 1024, 968, 912, 864, 0, 0, 0, 0, 
	1812, 1712, 1616, 1524, 1440, 1356, 1280, 1208, 1140, 1076, 1016, 960, 0, 0, 0, 0, 
	1800, 1700, 1604, 1516, 1428, 1348, 1272, 1200, 1136, 1072, 1012, 952, 0, 0, 0, 0, 
	1788, 1688, 1592, 1504, 1420, 1340, 1264, 1192, 1128, 1064, 1004, 948, 0, 0, 0, 0, 
	1776, 1676, 1580, 1492, 1408, 1328, 1256, 1184, 1120, 1056, 996, 940, 0, 0, 0, 0, 
	1764, 1664, 1568, 1480, 1400, 1320, 1248, 1176, 1112, 1048, 988, 932, 0, 0, 0, 0, 
	1748, 1652, 1560, 1472, 1388, 1312, 1236, 1168, 1104, 1040, 980, 928, 0, 0, 0, 0, 
	1736, 1640, 1548, 1460, 1380, 1300, 1228, 1160, 1096, 1032, 976, 920, 0, 0, 0, 0, 
	1724, 1628, 1536, 1452, 1368, 1292, 1220, 1152, 1088, 1024, 968, 912
};

const u8 sndSineTable[] = {
	0,		24,	49,	74,	97,	120,	141,	161,
	180,	197,	212,	224,	235,	244,	250,	253,
	255,	253,	250,	244,	235,	224,	212,	197,
	180,	161,	141,	120,	97,	74,	49,	24
};
