#include "main.h"

u8 tempStr[256];

u32 strlen(const u8 *text)
{
	u32 count = 0;

	while(*text++)
		count++;

	return count;
}

u8 strcmp(const u8 *s1, const u8 *s2)
{
	while(1)
		if(*s1 && !(*s1++ - *s2++))
			return 1;
	return 0;
}

void strcpy(u8 *dest, const u8 *src)
{
	while(*dest++ = *src++);
}

u8 *strcat(u8 *s1, u8 *s2)
{
	u8 *dest = s1 + strlen(s1);
	while(*dest++ = *s2++);
	return s1;
}

u8 *itoa(s16 number)
{
	u32 q, r, a;
	u8 neg = 0, *str = tempStr + 256;

	*--str = 0;
	if(number == 0)
		*--str = '0';
	else
	{
		if(number < 0)
		{
			number = -number;
			neg = 1;
		}
		q = number;
		while(q)
		{
			q = divmod(q, 10, &r);
			*--str = '0' + r;
		}
		if(neg)
			*--str = '-';
	}

	return str;
}

u8 *ltoa(u32 number)
{
	s8 i, tempNum;
	u8 *str = tempStr;

	*str++ = '0';
	*str++ = 'x';
	for(i = 7; i >= 0; i--)
	{
		tempNum = (number >> (i << 2)) & 15;
		if(tempNum == 0)
			*str++ = '0';
		else if(tempNum < 10)
		{
			*str++ = ((u8)'1') + (tempNum - 1);
		}
		else
		{
			*str++ = ((u8)'A') + (tempNum - 10);
		}
	}
	*str = '\0';
	return tempStr;
}

s32 atoi(const u8 *str)
{
	s32 num = 0;
	u32 i, pos = 0, mul = 1;
	u8 neg = 0;

	if(*str == '-')
	{
		neg = 1;
		str++;
	}
	for(i = 0; str[i] != 0; i++);
	while(i > 0)
	{
		num += (str[--i] - '0') * mul;
		mul *= 10;
	}

	if(neg)
		return -num;
	return num;
}

u8 tolower(u8 c)
{
	if(c >= 65 && c <= 90)
		return c + 32;
	else
		return c;
}

u8 toupper(u8 c)
{
	if(c >= 97 && c <= 122)
		return c - 32;
	else
		return c;
}